/**
 * @brief  Converter test program
 * @author Masayuki Shimizu <tmsimiz@ipc.shizuoka.ac.jp>
 * @note   Copyright (C) 2008 Masayuki Shimizu. All Rights Reserved.
 */

#include <iostream>
#include "../RotationConverter.h"

#define RAD(deg) (deg*M_PI/180.0)

int main(int argc, char* argv[])
{
  int i,j;
  std::vector<double> angle(3, 0.0);
  std::vector<std::vector<double> > R;
  
  //std::cout<<std::fixed;
  std::cout.precision(6);
  
  angle[0] = 0.0;
  angle[1] = RAD(89.0);
  angle[2] = 0.0;
  
  RotConv::rpy_to_matrix(angle, R);
  
  std::cout<<"Angle [deg]:";
  for(i=0;i<3;++i)
    std::cout<<" "<<(angle[i]*180.0/M_PI);
  std::cout<<std::endl;
  
  std::cout<<"Rotation matrix:"<<std::endl;
  for(i=0;i<3;++i){
    for(j=0;j<3;++j) std::cout<<" "<<R[i][j];
    std::cout<<std::endl;
  }
  std::cout<<std::endl;
  
  if(!RotConv::matrix_to_rpy(R, angle)){
    std::cout<<"Inversion failed"<<std::endl;
    return -1;
  }
  std::cout<<"Inverted Angle [deg]:";
  for(i=0;i<3;++i)
    std::cout<<" "<<(angle[i]*180.0/M_PI);
  std::cout<<std::endl;
  
  if(!RotConv::matrix_to_rpy(R, angle, false)){
    std::cout<<"Inversion failed"<<std::endl;
    return -1;
  }
  std::cout<<"Inverted Angle [deg]:";
  for(i=0;i<3;++i)
    std::cout<<" "<<(angle[i]*180.0/M_PI);
  std::cout<<std::endl;
  
  return 0;
}
