// -*- C++ -*-
/*!
 * @file  FwdKinematicsPA10.cpp * @brief Forward Kinematics of PA10-7c arm * $Date$ 
 *
 * $Id$ 
 */
#include "FwdKinematicsPA10.h"

// Module specification
// <rtc-template block="module_spec">
static const char* fwdkinematicspa10_spec[] =
  {
    "implementation_id", "FwdKinematicsPA10",
    "type_name",         "FwdKinematicsPA10",
    "description",       "Forward Kinematics of PA10-7c arm",
    "version",           "1.0",
    "vendor",            "Masayuki Shimizu",
    "category",          "Kinematics",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    ""
  };
// </rtc-template>

FwdKinematicsPA10::FwdKinematicsPA10(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_JointAngleIn("JointAngle", m_JointAngle),
    m_JointVelocityIn("JointVelocity", m_JointVelocity),
    m_TipPositionOut("TipPosition", m_TipPosition),
    m_TipVelocityOut("TipVelocity", m_TipVelocity)

    // </rtc-template>
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("JointAngle", m_JointAngleIn);
  registerInPort("JointVelocity", m_JointVelocityIn);

  // Set OutPort buffer
  registerOutPort("TipPosition", m_TipPositionOut);
  registerOutPort("TipVelocity", m_TipVelocityOut);

  // Set service provider to Ports

  // Set service consumers to Ports

  // Set CORBA Service Ports

  // </rtc-template>

}

FwdKinematicsPA10::~FwdKinematicsPA10()
{
}


RTC::ReturnCode_t FwdKinematicsPA10::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable

  // </rtc-template>
  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t FwdKinematicsPA10::onFinalize()
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t FwdKinematicsPA10::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t FwdKinematicsPA10::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t FwdKinematicsPA10::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t FwdKinematicsPA10::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t FwdKinematicsPA10::onExecute(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t FwdKinematicsPA10::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t FwdKinematicsPA10::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t FwdKinematicsPA10::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t FwdKinematicsPA10::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/
/*
RTC::ReturnCode_t FwdKinematicsPA10::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


extern "C"
{
 
  void FwdKinematicsPA10Init(RTC::Manager* manager)
  {
    RTC::Properties profile(fwdkinematicspa10_spec);
    manager->registerFactory(profile,
                             RTC::Create<FwdKinematicsPA10>,
                             RTC::Delete<FwdKinematicsPA10>);
  }
  
};



