/**
 * @brief Test program for matrix_util
 */

#include <iostream>
#include "matrix_util.h"

using namespace matrix_util;

int main(int argc, char** argv)
{
  std::vector<std::vector<double> > x(2);
  for(unsigned int i = 0; i < x.size(); ++i) x[i].resize(x.size());
  
  x[0][0] = 2.0; x[0][1] = 1.0;
  x[1][0] = 1.0; x[1][1] = 2.0;
  
  if(!is_square(x)) std::cout<<"Not square"<<std::endl;
  if(!is_symmetry(x)) std::cout<<"Not symmetry"<<std::endl;
  if(!is_diagonal(x)) std::cout<<"Not diagonal"<<std::endl;
  if(!is_positive(x)) std::cout<<"Not positive"<<std::endl;

  std::vector<double> u;
  std::vector<std::vector<double> > P;
  if(!jacobi(x,u,P)) std::cout<<"jacobi() failed"<<std::endl;
  std::cout<<"Eigen values: ";
  for(unsigned int i = 0; i < x.size(); ++i)
    std::cout<<u[i]<<" ";
  std::cout<<std::endl;
  std::cout<<"Eigen vectors: "<<std::endl;
  for(unsigned int i = 0; i < x.size(); ++i){
    for(unsigned int j = 0; j < x[i].size(); ++j)
      std::cout<<P[i][j]<<" ";
    std::cout<<std::endl;
  }
  
  return 0;
}
